/*   
 *    scope_graph.h
 *   ================
 *   Uwe Berger; 2013
 * 
 * Grafikroutinen fuer Scopeclock...
 * 
 * 
 * ---------
 * Have fun!
 *  
 */
#ifndef __SCOPE_GRAPH_H__
#define __SCOPE_GRAPH_H__ 
 
#include <stdint.h>
#include "my_math.h"
 
 // "Bildschirmaufloesung"
#define MAX_X				255
#define MAX_Y				255
#define DT_X				255/MAX_X
#define DT_Y				255/MAX_Y
#define R					MAX_X/2

// Zeichen-Definitionen
#define E			0xFF	// Zeichen Ende
#define F   		0xFE	// "Stift" absetzen
#define DDX 		3		// Zeichenbreite bei Zoom 1
#define DDY 		6		// Zeichenhöhe bei Zoom 1
#define DPX 		3		// Zeichenzwischenraum X
#define DPY 		3		// Zeichenzwischenraum Y
#define ZOOM_T		8		// Zoomfaktor Uhrzeit
#define ZOOM_D		4		// Zoomfaktor Datum
#define ZOOM_TEMP	6		// Zommfaktor Temperatur
static const uint8_t d[17][17][2] = {
	{{0,5},{0,1},{1,0},{2,0},{3,1},{3,5},{2,6},{1,6},{0,5},{3,1},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 0
	{{0,2},{2,0},{2,6},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 1
	{{0,1},{1,0},{2,0},{3,1},{3,2},{0,6},{3,6},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 2
	{{0,1},{1,0},{2,0},{3,1},{3,2},{2,3},{3,4},{3,5},{2,6},{1,6},{0,5},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 3
	{{3,3},{0,3},{2,0},{2,6},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 4
	{{3,0},{0,0},{0,3},{2,3},{3,4},{3,5},{2,6},{1,6},{0,5},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 5
	{{3,1},{2,0},{1,0},{0,1},{0,5},{1,6},{2,6},{3,5},{3,4},{2,3},{1,3},{0,4},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 6
	{{0,0},{3,0},{3,1},{0,6},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 7
	{{1,3},{0,2},{0,1},{1,0},{2,0},{3,1},{3,2},{2,3},{1,3},{0,4},{0,5},{1,6},{2,6},{3,5},{3,4},{2,3},{E,E}},	// 8
	{{0,5},{1,6},{2,6},{3,5},{3,1},{2,0},{1,0},{0,1},{0,2},{1,3},{2,3},{3,2},{E,E},{E,E},{E,E},{E,E},{E,E}},	// 9
	{{1,6},{2,6},{2,5},{1,5},{1,6},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// .
	{{1,6},{2,6},{2,5},{1,5},{1,6},{F,F},{1,3},{2,3},{2,2},{1,2},{1,3},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// :
	{{1,0},{2,0},{2,1},{1,1},{1,0},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// °
	{{2,0},{1,1},{1,5},{2,6},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// (
	{{1,0},{2,1},{2,5},{1,6},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// )
	{{3,1},{2,0},{1,0},{0,1},{0,5},{1,6},{2,6},{3,5},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}},	// C
	{{0,6},{0,0},{3,0},{F,F},{0,2},{2,2},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E},{E,E}}		// F
};

// *********************************
// richtet sich nach der Hardware, deshalb woanders zu definieren
extern void plot_point(uint8_t x, uint8_t y);

void plot_line(int x0, int y0, int x1, int y1);
void plot_rectangle(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1);
void plot_char (uint8_t px, uint8_t py, uint8_t c, uint8_t zoom);
void fat_hand (int val, int dist);
void digital_clock (uint8_t x, uint8_t y,
					uint8_t year, uint8_t month,uint8_t day,
					uint8_t hour, uint8_t minute, uint8_t secound,
					uint8_t mark);
void analog_clock  (uint8_t hour, uint8_t minute, uint8_t secound);
void draw_penguin(uint8_t x, uint8_t y, uint8_t zoom);
void draw_temperature(uint8_t x, uint8_t y, uint32_t temp_c);
void draw_all_pixel(void);
void plot_circle(int x0, int y0, int radius);
 
#endif
